unit Child;

interface

uses
    Windows, Classes, SysUtils, Graphics, Forms, Controls, StdCtrls,
  ExtCtrls, ComCtrls, Buttons, Menus;

type
  TChildForm = class(TForm)
    MemoTail: TMemo;
    Timer: TTimer;
    StatusBar1: TStatusBar;
    PopupMenu: TPopupMenu;
    PenuState: TMenuItem;
    N1: TMenuItem;
    PenuOpenFile: TMenuItem;
    PenuOpenFolder: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure TimerTimer(Sender: TObject);
    procedure PenuStateClick(Sender: TObject);
    procedure PenuOpenFileClick(Sender: TObject);
    procedure PenuOpenFolderClick(Sender: TObject);
  private
    TargetSize: integer;
    TargetModified: TDateTime;
  public
    TargetFile: string;
    TailCount: integer;
    procedure OnChangeMethod();
  end;

implementation

{$R *.dfm}

uses
    Main, fjUtil, Info;

//-----------------------------------------------------------------------------
//  Őݒ
procedure TChildForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caFree;
end;

//-----------------------------------------------------------------------------
//  EBhEIXg폜
procedure TChildForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
    Timer.Enabled := False;
    MainForm.CallOnReleaseMDIChild(Self);
end;

//-----------------------------------------------------------------------------
//  EBhEIXgŎI
procedure TChildForm.FormActivate(Sender: TObject);
begin
    MainForm.CallOnActivateMDIChild(Self);
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TChildForm.FormCreate(Sender: TObject);
begin
    //  oϐ
    TargetSize := 0;
    TargetModified := 0;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TChildForm.FormDestroy(Sender: TObject);
begin
    //
end;

//-----------------------------------------------------------------------------
//  ύX`FbN
procedure TChildForm.OnChangeMethod();
var
    OldSize: integer;
    OldModified: TDateTime;
begin
    //  Ώۃt@C̑݃`FbN
    if FileExists(TargetFile) then
    begin
        //  obNAbv
        OldSize     := TargetSize;
        OldModified := TargetModified;

        //  TCY擾
        TargetSize := FileSizeByFileStream(TargetFile);

        //  ύX擾
        TargetModified := FileModifiedByGetFileTime(TargetFile);

        //  ύXĂ邩H
        if (OldSize <> TargetSize) or (OldModified <> TargetModified) then
        begin
            //  \
            Tail(TargetFile, MemoTail.Lines, TailCount, 1024 * 2);

            //  \-2
            StatusBar1.Panels[0].Text := Format('[ByteSize] %s', [SizeText(TargetSize)]);
            StatusBar1.Panels[1].Text := Format('[Modified] %s', [DateText(TargetModified)]);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ύXĎ
procedure TChildForm.TimerTimer(Sender: TObject);
begin
    Timer.Enabled := False;
    OnChangeMethod();
    Timer.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  ~ƍĊJ
procedure TChildForm.PenuStateClick(Sender: TObject);
const
    CAP: array[Boolean] of string = ('~(&R)', '~(&R)');
begin
    Timer.Enabled := not Timer.Enabled;
    TMenuItem(Sender).Caption := CAP[Timer.Enabled];
end;

//-----------------------------------------------------------------------------
//  ̃t@CJ
procedure TChildForm.PenuOpenFileClick(Sender: TObject);
begin
    SimpleShellExecute(Self.Caption);
end;

//-----------------------------------------------------------------------------
//  ̃tH_J
procedure TChildForm.PenuOpenFolderClick(Sender: TObject);
begin
    SimpleShellExecute(ExtractFilePath(Self.Caption));
end;

end.
