unit Main;

interface

uses
    Windows, Messages, SysUtils, Classes, Forms, Controls, Menus, Graphics,
    ExtCtrls, StdCtrls, Buttons, ActnList, StdActns, ImgList, ComCtrls,
    ToolWin, IniFiles;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    ActionList: TActionList;
    WindowClose1: TWindowClose;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowTileVertical1: TWindowTileVertical;
    WindowMinimizeAll1: TWindowMinimizeAll;
    WindowArrange1: TWindowArrange;
    MenuWindow: TMenuItem;
    MenuArrangeIcon: TMenuItem;
    MenuCascade: TMenuItem;
    MenuClose: TMenuItem;
    MenuMinimizeAll: TMenuItem;
    MenuTileHorizontal: TMenuItem;
    MenuTileVertical: TMenuItem;
    Panel1: TPanel;
    ImageList: TImageList;
    MenuConfig: TMenuItem;
    MenuPutSetFore: TMenuItem;
    Panel2: TPanel;
    ImgBack: TImage;
    ImgBtnFace: TImage;
    ToolBar: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ListBox1: TListBox;
    Panel3: TPanel;
    EditInterval: TEdit;
    UpdnInterval: TUpDown;
    Label1: TLabel;
    BtnSetInterval: TBitBtn;
    Label2: TLabel;
    EditExtension: TEdit;
    MenuFile: TMenuItem;
    MenuExit: TMenuItem;
    FileExit1: TFileExit;
    MenuRestore: TMenuItem;
    MenuSaveList: TMenuItem;
    Label3: TLabel;
    EditRowCount: TEdit;
    UpdnRowCount: TUpDown;
    Help1: TMenuItem;
    MenuAbout: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1Click(Sender: TObject);
    procedure BtnSetIntervalClick(Sender: TObject);
    procedure MenuRestoreClick(Sender: TObject);
    procedure MenuSaveListClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
  private
    FClientWndProc: Pointer;
    FOrgWndProc: Pointer;
    AllocHandle:HWND;
    procedure ClientWndProc(var Msg: TMessage);
    procedure CreateMDIChild(const Name: string);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  private
  private
    FStrBuf: TStringList;
  protected
    procedure CreateParams(var Params: TCreateParams);override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure CallOnReleaseMDIChild(Sender: TForm);
    procedure CallOnActivateMDIChild(Sender: TForm);
  end;

var
    MainForm: TMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const
    UNIQUE_NAM: string = '{63C752F1-293E-495A-9367-C62D1DD624B0}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

{$R *.dfm}

uses
    child, ShellApi, Info;

//-----------------------------------------------------------------------------
//  j[NȃNXw肵ăbZ[WMpEBhE֐
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
function AllocMsgWnd(Method: TWndMethod; ClassName:string): HWND;
var
    DummyClass: TWndClass;
begin
    FillChar(DummyClass, SizeOf(TWndClass), #0);
    DummyClass.hInstance := hInstance;
    DummyClass.lpfnWndProc := @DefWindowProc;
    DummyClass.lpszClassName := PChar(ClassName);
    Windows.RegisterClass(DummyClass);
    Result := CreateWindowEx(WS_EX_TOOLWINDOW, DummyClass.lpszClassName,
                             '', WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
    if Assigned(Method) then
        SetWindowLong(Result,GWL_WNDPROC,LongInt(Classes.MakeObjectInstance(Method)));
end;

//-----------------------------------------------------------------------------
//  RXgN^
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    // \bhƂĒ`EBhEvV[WGg|Cg쐬
    FClientWndProc := Classes.MakeObjectInstance(ClientWndProc);
    // 쐬łAMDI NCAg̃EBhEvV[WƂ
    // o^ÃGgۑ
    if FClientWndProc <> nil then
    begin
        FOrgWndProc := Pointer(SetWindowLong(ClientHandle, GWL_WNDPROC,
                                            Longint(FClientWndProc)));
    end;
    //  bZ[WMp
    if AllocHandle = 0 then AllocHandle := AllocMsgWnd(ClientWndProc, UNIQUE_NAM);
end;
//-----------------------------------------------------------------------------
//  fXgN^
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
destructor TMainForm.Destroy;
begin
    // fXgN^ŃEBhEvV[Wɖ߂
    if FOrgWndProc <> nil then
    begin
        SetWindowLong(ClientHandle, GWL_WNDPROC, Longint(FOrgWndProc));
    end;
    //  bZ[WMp
    Classes.DeallocateHwnd(AllocHandle);
    AllocHandle := 0;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
procedure TMainForm.ClientWndProc(var Msg: TMessage);
var
    R: TRect;
    i: integer;
    Buf: PChar;
    CopyData: PCopyDataStruct;
begin
    case Msg.Msg of

    //  wi`掞
    WM_ERASEBKGND:
        begin
            //  MDINCAg̈擾
            Windows.GetClientRect(ClientHandle, R);
            //  w̃rbg}bvœhԂ
            Brush.Bitmap := ImgBack.Picture.Bitmap;
            FillRect(TWMEraseBkgnd(Msg).DC, R, Brush.Handle);
            Brush.Bitmap := nil;
            Paint();
        end;

    //  ʂ̃CX^X瑗Ăe
    WM_COPYDATA:
        begin
            CopyData := PCopyDataStruct(Msg.LParam);
            if CopyData^.dwData = UNIQUE_NUM then
            begin
                Buf := StrALloc(CopyData^.cbData);
                try
                    StrCopy(Buf, CopyData^.lpData);
                    FStrBuf.CommaText := Buf;
                finally
                    StrDispose(Buf);
                end;
                for i := 0 to FStrBuf.Count - 1 do
                begin
                    CreateMDIChild(FStrBuf.Strings[i]);
                end;
            end;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(FOrgWndProc, ClientHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    FileName: Array[0..MAX_PATH] of Char;
    i, Count: integer;
begin
    //  hbvꂽt@C̐擾
    Count := DragQueryFile(Msg.Drop, DWORD(-1), FileName, SizeOf(FileName));
    for i := 0 to Count - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
        //  ꂪt@CȂ
        if (FileExists(FileName)) then
        begin
            //  qʋN
            CreateMDIChild(FileName);
        end;
        //  őOʂɎĂ
        if (MenuPutSetFore.Checked) then SetForegroundWindow(Application.Handle);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  LvVݒ
    Self.Caption := Application.Title + ' - ' + Self.Name;

    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
    begin
        try
            //  ʒuČ
            Self.Left := ReadInteger('Position', 'Left', Self.Left);
            Self.Top  := ReadInteger('Position', 'Top', Self.Top);
            Self.Height := ReadInteger('Position', 'Height', Self.Height);
            Self.Width := ReadInteger('Position', 'Width', Self.Width);

            //  ̑
            UpdnInterval.Position := ReadInteger('Setting', 'Interval', UpdnInterval.Position);
            UpdnRowCount.Position := ReadInteger('Setting', 'RowCount', UpdnRowCount.Position);
            EditExtension.Text := ReadString('Setting', 'Extension', EditExtension.Text);
        finally
            Free();
        end;
    end;

    //  GpXg쐬
    FStrBuf := TStringList.Create;
    //  EBhEIXg\[g
    ListBox1.Sorted := true;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  GpXgj
    FStrBuf.Free;

    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
    begin
        try
            //  ʒuL^
            WriteInteger('Position', 'Left', Self.Left);
            WriteInteger('Position', 'Top', Self.Top);
            WriteInteger('Position', 'Height', Self.Height);
            WriteInteger('Position', 'Width', Self.Width);

            //  ̑
            WriteInteger('Setting', 'Interval', UpdnInterval.Position);
            WriteInteger('Setting', 'RowCount', UpdnRowCount.Position);
            WriteString('Setting', 'Extension', EditExtension.Text);
        finally
            Free();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ݂̊Ďt@CL^
procedure TMainForm.MenuSaveListClick(Sender: TObject);
var
    i: integer;
begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
    begin
        try
            //  \̃t@CL^
            for i := 0 to ListBox1.Items.Count - 1 do
            begin
                WriteString('History', Format('%5.5d', [i]), ListBox1.Items[i]);
            end;
        finally
            Free();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  OȈԂɕA
procedure TMainForm.MenuRestoreClick(Sender: TObject);
var
    i: integer;
begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini')) do
    begin
        try
            FStrBuf.Clear();
            ReadSection('History', FStrBuf);
            for i := 0 to FStrBuf.Count - 1 do
            begin
                CreateMDIChild(ReadString('History', FStrBuf[i], ''));
            end;
        finally
            Free();
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  tH[\
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        CreateMDIChild(ParamStr(i));
    end;
end;

//-----------------------------------------------------------------------------
//  qʍ쐬
procedure TMainForm.CreateMDIChild(const Name: string);
var
    Child: TChildForm;
    index: integer;
    Ext: string;
begin
    //  ɓo^ĂȂ
    index := ListBox1.Items.IndexOf(Name);

    if (index <> -1) then
    begin
        ListBox1.ItemIndex := index;
        ListBox1Click(ListBox1);
    end
    else
    begin
        Ext := AnsiLowerCase(ExtractFileExt(Name));
        if (Pos(Ext, EditExtension.Text) > 0) then
        begin
            Child := TChildForm.Create(Application);
            Child.Caption := Name;
            ListBox1.Items.AddObject(Name, Child);
            CallOnActivateMDIChild(Child);

            //  ݒ
            Child.TailCount := 10;
            Child.Timer.Interval := UpdnInterval.Position;
            //  ĎΏۂZbg
            Child.TargetFile := Name;

            Child.OnChangeMethod();
            Child.Timer.Enabled := True;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  qʍ폜
procedure TMainForm.CallOnReleaseMDIChild(Sender: TForm);
var
    Child: TChildForm;
    index: integer;
begin
    Child := TChildForm(Sender);
    index := ListBox1.Items.IndexOfObject(Child);
    if (index <> -1) then ListBox1.Items.Delete(index);
end;

//-----------------------------------------------------------------------------
//  qʃANeBu
procedure TMainForm.CallOnActivateMDIChild(Sender: TForm);
var
    Child: TChildForm;
begin
    Child := TChildForm(Sender);
    ListBox1.ItemIndex := ListBox1.Items.IndexOfObject(Child);
end;

//-----------------------------------------------------------------------------
//  EBhEIXgI
procedure TMainForm.ListBox1Click(Sender: TObject);
var
    LBox: TListBox;
    Child: TChildForm;
begin
    LBox := TListBox(Sender);
    if (LBox.ItemIndex <> -1) then
    begin
        Child := TChildForm(LBox.Items.Objects[LBox.ItemIndex]);
        if (Child <> nil) then
        begin
            Child.BringToFront;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  \ς݊ĎEBhE̊ĎԊuύX
procedure TMainForm.BtnSetIntervalClick(Sender: TObject);
var
    i: integer;
    Child: TChildForm;
begin
    for i := 0 to ListBox1.Count - 1 do
    begin
        Child := TChildForm(ListBox1.Items.Objects[ListBox1.ItemIndex]);
        if (Child <> nil) then
        begin
            Child.Timer.Interval := UpdnInterval.Position;
            Child.TailCount      := UpdnRowCount.Position; 
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  EBhEIXg`掞
//  http://kazina.jugem.jp/?eid=55
procedure TMainForm.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    LBox: TListBox;
    FileName, DispName: string;
    OffsetX, OffsetY: integer;
begin
    LBox := TListBox(Control);

    //  `e
    FileName := LBox.Items.Strings[Index];
    DispName := ExtractFileName(FileName);

    //  `ʒu
    OffsetX := Rect.Left + 5;
    OffsetY := Rect.Top + (Rect.Bottom - Rect.Top - LBox.Canvas.TextHeight('Wg')) div 2;

    //  wihԂ
    if (odFocused in State) then
    begin
        LBox.Canvas.Brush.Color := $00D2BDB6;
        LBox.Canvas.FillRect(Rect);
        LBox.Canvas.Brush.Color := $006A240A;
        LBox.Canvas.FrameRect(Rect);
        LBox.Canvas.DrawFocusRect(Rect);
    end
    else if (odSelected in State) then
    begin
        LBox.Canvas.Brush.Color := $00D2BDB6;
        LBox.Canvas.FillRect(Rect);
        LBox.Canvas.DrawFocusRect(Rect);
    end
    else
    begin
        LBox.Canvas.Brush.Color := $00F7F8F9;
        LBox.Canvas.FillRect(Rect);
    end;

    //  LvV`
    LBox.Canvas.Font.Color := clBlack;
    LBox.Canvas.Brush.Style := bsClear;
    LBox.Canvas.TextOut(OffsetX, OffsetY, DispName);
    LBox.Canvas.Brush.Style := bsSolid;
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

end.
