unit fjUtil;

interface

uses
    Windows, SysUtils, Classes, DateUtils;

function DateText(const AFrom, ATo: TDateTime): string; overload;
function DateText(const Dt: TDateTime): string; overload;
function SizeText(const ByteSize: integer): string;
procedure Tail(const Path: string; Lines: TStrings; const Count: integer; const MaxLineByteSize: integer);
function FileSizeByFileStream(const FileName: string): Int64;
function FileModifiedByGetFileTime(const FileName: string): TDateTime;

implementation

//  ---------------------------------------------------------------------------
//  oߕ\
function DateText(const AFrom, ATo: TDateTime): string;
var
    Sec, MillSec: Int64;
begin
    MillSec := MilliSecondsBetween(AFrom, ATo);
    Sec := SecondsBetween(AFrom, ATo);

    if (Sec > 10) then
        Result := FormatFloat('#,##0 sec', Sec)
    else
        Result := FormatFloat('#,##0 msec', MillSec)
    ;
end;

//  ---------------------------------------------------------------------------
//  t\
function DateText(const Dt: TDateTime): string;
begin
    Result := FormatDateTime('c', Dt);
end;

//  ---------------------------------------------------------------------------
//  oCgTCY\
function SizeText(const ByteSize: integer): string;
var
    MegaByte, KiloByte: double;
begin
    KiloByte := ByteSize / 1024;
    MegaByte := KiloByte / 1024;

    if (MegaByte > 10) then
        Result := FormatFloat('#,##0 MB', MegaByte)
    else if (KiloByte > 10) then
        Result := FormatFloat('#,##0 KB', KiloByte)
    else
        Result := FormatFloat('#,##0 B', ByteSize)
    ;
end;

//  ---------------------------------------------------------------------------
//  Ns\
procedure Tail(const Path: string; Lines: TStrings; const Count: integer; const MaxLineByteSize: integer);
var
    FS: TFileStream;
    SL: TStringList;
    i, First, Final: integer;
    NewPosition: integer;
begin
    //  IuWFNg
    FS := nil;
    SL := nil;
    try
        try
            //  t@CJ
            FS := TFileStream.Create(Path, fmOpenRead or fmShareDenyNone);
            //  ƗpXg쐬
            SL := TStringList.Create;
            //  XgύXCxg~
            SL.BeginUpdate();
            Lines.BeginUpdate();
            //  ző1sTCYɑ
            NewPosition := FS.Size - Count * MaxLineByteSize;
            if (NewPosition < 0) then NewPosition := 0;
            FS.Seek(NewPosition, soFromBeginning);
            //  ƗpXgɓǂݏo
            SL.LoadFromStream(FS);
            //  ŏIsԍ擾
            Final := SL.Count - 1;
            //  SȂH
            if (Count = -1) then First := 0 else First := Final - Count + 1;
            if (First < 0) then First := 0;
            //  ŏI݃XgNA
            Lines.Clear();
            //  wsXgɏ
            for i := First to Final do Lines.Add(SL.Strings[i]);
            //  XgύXCxgĊJ
            Lines.EndUpdate();
            SL.EndUpdate();
        finally
            //  IuWFNgj
            SL.Free;
            FS.Free;
        end;
    except
        ;
    end;
end;

//  ---------------------------------------------------------------------------
//  t@CTCY擾(TFileStream)
function FileSizeByFileStream(const FileName: string): Int64;
begin
    Result := -1;
    try
        with TFileStream.Create(FileName, fmOpenRead or fmShareDenyNone) do
        begin
            try
                Result := Size;
            finally
                Free;
            end;
        end;
    except
    end;
end;

//  ---------------------------------------------------------------------------
//  ŏIXV擾(GetFileTime)
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#datetimefile2
function FileModifiedByGetFileTime(const FileName: string): TDateTime;
var
    FileHandle: integer;
    ftCreateDate: TFileTime;
    ftModifyDate: TFileTime;
    ftAccessDate: TFileTime;
    lftModifyDate: TFileTime;
    stModifyDate: TSystemTime;
begin
    Result := 0;
    try
        FileHandle := FileOpen(FileName, fmOpenRead or fmShareDenyNone);
        if (FileHandle >= 0) then
        begin
            try
                //  t@C̓擾
                GetFileTime(FileHandle, @ftCreateDate, @ftAccessDate, @ftModifyDate);
                //  [JɕύX
                FileTimeToLocalFileTime(ftModifyDate, lftModifyDate);
                //  VXeɕύX
                FileTimeToSystemTime(lftModifyDate, stModifyDate);
                Result := SystemTimeToDateTime(stModifyDate);
            finally
                FileClose(FileHandle);
            end;
        end;
    except
    end;
end;

end.

